/***************************************************************************
 *                                                                         *
 *    NoMoRe++                                                             *
 *                                                                         *
 *    Copyright (C) 2003-2005 NoMoRe Developing Group                      *
 *                                                                         * 
 *    For more information, see http://www.cs.uni-potsdam.de/nomore/       *
 *    or email to nomore-dg@cs.uni-potsdam.de                              *
 *                                                                         *
 *                                                                         *
 *    This program is free software; you can redistribute it and/or        *
 *    modify it under the terms of the GNU General Public License          *
 *    as published by the Free Software Foundation; either version 2       *
 *    of the License, or (at your option) any later version.               *
 *                                                                         *
 *    This program is distributed in the hope that it will be useful,      *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 *    GNU General Public License for more details.                         *
 *                                                                         *
 *    You should have received a copy of the GNU General Public License    *
 *                                                                         * 
 ***************************************************************************/

#include <binary_backtracking_solver.h>
#include <graph.h>
#include <operator.h>
#include <choice_operator.h>
namespace NS_NOMORE {

BinaryBacktrackingSolver::BinaryBacktrackingSolver() 
  : Solver(){  
}  

BinaryBacktrackingSolver::BinaryBacktrackingSolver(int as, Propagator* prop, Lookahead* look, ChoiceOperator* choice, Printer* printer)
  : Solver(as, prop, look, choice, printer) {
}

bool BinaryBacktrackingSolver::backtrack(Graph& grp) {
  return grp.recolorChoicePoint();
}

bool BinaryBacktrackingSolver::choose(Graph&) {
  return (*choice_)();
}

}
